/* Diese Datei soll an Beispielfunktionen die Erstellung von Programmen
  fr den Konverters CNV 1318A veranschaulichen. Dabei wird vorrausgesetzt,
  da hier als Host ein PC mit einer RS485-Schnittstelle vom Typ RS1295
  eingesetzt wird.

  Das Programm und deren Funktionen sind nicht optimiert. Die Fehlerfreiheit
  dieses Programmes kann nicht garantiert werden.

  Das Programm liest permanent einige Daten der ersten 20 Bus-Teilnehmer
  ein und stellt sie auf dem Bildschirm dar. Der Konvertierungsbefehl ist
  hier auch implementiert, wird aber durch das Beispielprogramm nicht
  eingesetzt. */
#include <conio.h>;
#include <stdio.h>
#include <string.h>;
#include <dos.h>


int  PC_ADRESSE=29;               /* RS485-Adresse des PC's */
int  RS485_ADRESSE=0x100;        /* IO-Adresse der RS485-Schnittstelle */


  char Test[20];
  int  x;
  /*------------------------------------------------------------------*/
  void WandelInASCII(int Wert, char *ZeichenKette)
  {
    int HighByte,LowByte;

    /* Integerwert in ASCII wandeln */
    /* Byte aufteilen in Nibble */
    HighByte=(Wert & 0xF0)>> 4;
    LowByte =Wert & 15;
    /* Oberes Nibble in Zeichen wandeln */
    if (HighByte>9)
      HighByte=HighByte+'A'-10;
    else
      HighByte=HighByte+'0';
    /* Unteres Nibble in Zeichen wandeln */
    if (LowByte>9)
      LowByte=LowByte+'A'-10;
    else
      LowByte=LowByte+'0';
    ZeichenKette[0]=HighByte;
    ZeichenKette[1]=LowByte;
    ZeichenKette[2]=0;
  }
  /*------------------------------------------------------------------*/
  int ASCII2HEX(char Zeichen)
    {
      int x;
      
      switch (Zeichen)
	{
	case '0' :
	case '1' :
	case '2' :
	case '3' :
	case '4' :
	case '5' :
	case '6' :
	case '7' :
	case '8' :
	case '9' : x=Zeichen-'0'; break;
	case 'A' :
	case 'B' :
	case 'C' :
	case 'D' :
	case 'E' :
	case 'F' : x=Zeichen-'A'+10; break;
	default :  	x=0;
	}
      return(x);
    }
  /*-----------------------------------------------------------------*/
  int WandelInBinaer(char *ZeichenKette)
    {
    int Wert;
    /* 2-ZeichenASCII-Wert in Binrwert wandeln */
    /* Oberes Nibble bearbeiten */
    Wert=ASCII2HEX(ZeichenKette[0]) << 4;
    Wert=Wert+ASCII2HEX(ZeichenKette[1]);
    return(Wert);
    }
  /*------------------------------------------------------------------*/
  void PruefsummeEinfuegen(char *SendeZeichenKette)
    {
    int x;
    int y;
    char ASCII_Wert[3];

    y=0;
    /* Summe der ASCII-Zeichen bilden */
    for (x=0;x<strlen(SendeZeichenKette);x++)
      y=y+SendeZeichenKette[x];
    /* Nur 8-Bit Summe verwenden */
    y=y & 0xFF;
    /* Prfsumme in ASCII-Zeichen wandeln */
    WandelInASCII(y,ASCII_Wert);
    /* Prfsumme an Sendezeichenkette anhngen */
    strcat(SendeZeichenKette,ASCII_Wert);
    }
  /*------------------------------------------------------------------*/
  /* HINWEIS : Die Initialisierungsroutine ist fr den Einstatz der RS485-Karte vom
    Typ ERMA RS1295 ausgelegt. Die Routine ist im Einzelfall an die
    verwendete RS485-Schnittstelle anzupassen! */
  /* RS485-Schnittstelle einstellen (115200,8,N,1) */
  void Init_RS485(void)
    {
    /* Umschalten auf Baudratenteiler */
    outportb(RS485_ADRESSE+3,0x80);
    /* Baudrate auf 115200 einstellen */
    outportb(RS485_ADRESSE+1,0x00);
    outportb(RS485_ADRESSE  ,0x01);
    /**/
    outportb(RS485_ADRESSE+3,0x03);
    /**/
    outportb(RS485_ADRESSE+1,0x00);
    /**/
    outportb(RS485_ADRESSE+2,0x03);
    }
  /*------------------------------------------------------------------*/
  /* HINWEIS : Die Senderoutine ist fr den Einstatz der RS485-Karte vom
    Typ ERMA RS1295 ausgelegt. Die Routine ist im Einzelfall an die
    verwendete RS485-Schnittstelle anzupassen! In dieser Routine wird der
    Einfachheit halber auf die Interruptprogrammierung verzichtet, obwohl
    sie zu empfehlen ist. */
  void Senden(char *SendeZeichenKette)
    {
    int x,y;
    int TimeOut;

    /* Eingangspuffer lschen (alle Zeichen entfernen) */
    while((inportb(RS485_ADRESSE+5) & 1)==1) y=inportb(RS485_ADRESSE);
    /* Ausgangstreiber der RS485-Schnittstelle einschalten */
    outport(RS485_ADRESSE+4,0x01);
    /* String senden */
    for (x=0;x<strlen(SendeZeichenKette);x++)
      {
      /* Zeichen aus String senden */
      outportb(RS485_ADRESSE,SendeZeichenKette[x]);
      TimeOut=0;
      /* Warten auf RS485-Echo */
      /* HINWEIS: Die hier gewhlte Methode des Timeouts ist nur sehr
	einfach. Der Wert hngt von der gewhlten Baudrate und der
	Computergeschwindigkeit ab. Um einheitliche TimeOut-Zeiten auf
	unterschiedlichen Computersystemen zu erreichen sollte der
	Timer des PC's verwendet werden. */
      while (((inportb(RS485_ADRESSE+5) & 1)==0) & (TimeOut<10000)) TimeOut++;
      /* Echo einlesen */
      y=inportb(RS485_ADRESSE);
      /* Wenn Fehler beim Senden, dann Ende der bertragung an Konverter
	schicken. */
      if (y!=SendeZeichenKette[x])
	{
	outportb(RS485_ADRESSE,13);
	outportb(RS485_ADRESSE,10);
	}
      }
    /* RS485-Treiber ausschalten */
    outport(RS485_ADRESSE+4,0x00);
  }
  /*------------------------------------------------------------------*/
  /* HINWEIS : Die Empfangsroutine ist fr den Einstatz der RS485-Karte vom
    Typ ERMA RS1295 ausgelegt. Die Routine ist im Einzelfall an die
    verwendete RS485-Schnittstelle anzupassen! In dieser Routine wird der
    Einfachheit halber auf die Interruptprogrammierung verzichtet, obwohl
    sie zu empfehlen ist. */
  void Empfangen(char *EmpfangsZeichenKette)
    {
    long TimeOut;
    int x,y;
    int Ende;

    /* Antwort empfangen */
    x=0;
    Ende=0;
    strcpy(EmpfangsZeichenKette,"");
    TimeOut=0L;
    do
      {
      /* HINWEIS: Die hier gewhlte Methode des Timeouts ist nur sehr
	einfach. Der Wert hngt von der gewhlten Baudrate und der
	Computergeschwindigkeit ab. Um einheitliche TimeOut-Zeiten auf
	unterschiedlichen Computersystemen zu erreichen sollte der
	Timer des PC's verwendet werden. */
      /* Warten auf Zeichen an RS485-Schnittstelle, bzw. auf TimeOut */
	/*TimeOut-Zhler erhhen */
	TimeOut++;

	/* Falls kein TimeOut, dann */
	if (TimeOut<10000L)
	  {
	    if ((inportb(RS485_ADRESSE+5) & 1) == 1)
	      {
	      /* Zeichen von RS485 einlesen */
	      y=inportb(RS485_ADRESSE);
	      /* In Empfangszeichenkette ablegen */
	      EmpfangsZeichenKette[x]=y;
	      /* Prfen auf bertragungsende */
	      if (EmpfangsZeichenKette[x]==10)
		Ende=1;
	      /* Zeichenzhler erhhen */
	      x++;
	      TimeOut=0L;
	      /* Wenn mehr als 30 Zeichen, dann abbrechen */
	      if (x>30)
		Ende=1;
	      }
	  }
	else
	  /* Bei TimeOut abbrechen */
	  Ende=1;
      }
    while (Ende!=1);
    EmpfangsZeichenKette[x]=0;
  }
  /*------------------------------------------------------------------*/
  /*##################################################################
    ###            Grundfunktionen fr den CNV1318A                ###
    ##################################################################*/
  /* Diese Prozedur ermittelt die Gertebezeichnung des Gertes mit der
    angegebenen Busnummer. Dies ist zum Beispiel von Vorteil, wenn
    unterschiedliche Gerte an einem einzigen Bus angeschlossen sind.
    Die ERMA-Megerte mit RS485 kennen das Kommando GER? auch. Somit
    wre zum Beispiel eine automatische Konfiguration mglich. Eine
    zweite Mglichkeit wre, da die Revisionsnummer (hier A) dazu
    benutzt wird, um zu unterscheiden, welche Befehle bei der jeweiligen
    Revision benutzt werden knnen und welche nicht. */
  void CNV1318A_GER(int BusNummer, char *Bezeichnung)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Anzahl der Daten einfgen */
    strcat(SendeZeichenKette,"04");
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"GER?");
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Bezeichnung aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(Bezeichnung,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Zeichen der Bezeichnung in Zielzeichenkette kopieren */
      for (x=10;x<(strlen(EmpfangsZeichenKette)-4);x++)
	Bezeichnung[x-10]=EmpfangsZeichenKette[x];
      Bezeichnung[x-10]=0;
      }
  }
  /*------------------------------------------------------------------*/
  /* Diese Prozedur ermittelt die Versionsnummer der Software des Gertes
    mit der angegebenen Busnummer. Dies ist zum Beispiel von Vorteil, wenn
    unterschiedliche Versionen eines Gertes an einem einzigen Bus
    angeschlossen sind, da automatisch unterschieden werden kann, welche
    Gerte welche Befehle verstehen. */
  void CNV1318A_VER(int BusNummer, char *Version)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Anzahl der Daten einfgen */
    strcat(SendeZeichenKette,"04");
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"VER?");
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Versionsnummer aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(Version,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Zeichen der Versionsnummer in Zielzeichenkette kopieren */
      for (x=10;x<strlen(EmpfangsZeichenKette)-4;x++)
	Version[x-10]=EmpfangsZeichenKette[x];
      Version[x-10]=0;
      }
  }
  /*------------------------------------------------------------------*/
  /* Diese Prozedur ermittelt die Seriennummer des Gertes
    mit der angegebenen Busnummer. */
  void CNV1318A_SRN(int BusNummer, char *SerienNummer)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Anzahl der Daten einfgen */
    strcat(SendeZeichenKette,"04");
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"SRN?");
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Seriennummer aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(SerienNummer,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Zeichen der Seriennummer in Zielzeichenkette kopieren */
      for (x=10;x<strlen(EmpfangsZeichenKette)-4;x++)
	SerienNummer[x-10]=EmpfangsZeichenKette[x];
      SerienNummer[x-10]=0;
      }
  }
  /*------------------------------------------------------------------*/
  /* Diese Prozedur ermittelt das Herstellungsdatum des Gertes
    mit der angegebenen Busnummer. */
  void CNV1318A_DAT(int BusNummer, char *HerstellungsDatum)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Anzahl der Daten einfgen */
    strcat(SendeZeichenKette,"04");
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"DAT?");
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Herstellungsdatum aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(HerstellungsDatum,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Zeichen des Herstellungsdatums in Zielzeichenkette kopieren */
      for (x=10;x<strlen(EmpfangsZeichenKette)-4;x++)
	HerstellungsDatum[x-10]=EmpfangsZeichenKette[x];
      HerstellungsDatum[x-10]=0;
      }
  }
  /*------------------------------------------------------------------*/
  /* Diese Prozedur ermittelt die bertragungsparameter der RS232 des
    Konverters mit der angegebenen Busnummer. */
  void CNV1318A_GETMD(int BusNummer, char *Mode)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Anzahl der Daten einfgen */
    strcat(SendeZeichenKette,"06");
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"SETMD?");
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Mode aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(Mode,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Zeichen des Modes in Zielzeichenkette kopieren */
      for (x=12;x<strlen(EmpfangsZeichenKette)-4;x++)
	Mode[x-12]=EmpfangsZeichenKette[x];
      Mode[x-12]=0;
      }
  }
  /*------------------------------------------------------------------*/
  /* Diese Prozedur setzt die bertragungsparameter der RS232 des
    Konverters mit der angegebenen Busnummer. Die Parameter mssen als
    String vorliegen! */
  void CNV1318A_SETMD(int BusNummer, char *Mode)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Anzahl der Daten einfgen */
    strcat(SendeZeichenKette,"07");
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"SETMD");
    /* Mode anfgen */
    strcat(SendeZeichenKette,Mode);
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Mode aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(Mode,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Zeichen des Modes in Zielzeichenkette kopieren */
      for (x=12;x<strlen(EmpfangsZeichenKette)-4;x++)
	Mode[x-12]=EmpfangsZeichenKette[x];
      Mode[x-12]=0;
      }
  }
  /*------------------------------------------------------------------*/
  /* Diese Prozedur bertrgt eine Zeichenkette an die RS232 ber den
    Konverters mit der angegebenen Busnummer. */
  /* HINWEIS: Der Parameter ZeichenKette wird als Ein- und als Ausgabeparameter
    mibraucht. Beim Prozeduraufruf mu er die Zeichenkette enthalten, die
    an die RS232 bertragen werden soll, nach Beendigung enthlt er die
    Antwort von der RS232 */
  void CNV1318A_CNV(int BusNummer, char *ZeichenKette)
    {
    /* zu sendende Zeichenkette */
    char SendeZeichenKette[80];
    /* empfangene Zeichenkette */
    char EmpfangsZeichenKette[80];
    /* 2-Zeichen-ASCII-Wert */
    char ASCII_Wert[3];
    /* Hilfsvariable */
    int x,y,BinWert;

    /* Sendezeichenkette zusammensetzen */
    /* erstes Zeichen '#' */
    strcpy(SendeZeichenKette,"#");
    /* BusNummer in ASCII wandeln und einfgen */
    WandelInASCII(BusNummer,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* PC-Nummer in ASCII wandeln und einfgen */
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);

    /* Anzahl der Daten einfgen */
    x=2*strlen(ZeichenKette);
    x=x+3;
    WandelInASCII(x,ASCII_Wert);
    strcat(SendeZeichenKette,ASCII_Wert);
    /* Befehl einfgen */
    strcat(SendeZeichenKette,"CNV");
    /* Daten einfgen */
    for (x=0;x<strlen(ZeichenKette);x++)
      {
      y=ZeichenKette[x];
      WandelInASCII(y,ASCII_Wert);
      strcat(SendeZeichenKette,ASCII_Wert);
      }
    /* Prfsumme berechnen und einfgen */
    PruefsummeEinfuegen(SendeZeichenKette);
    /* CR und LF einfgen */
    strcat(SendeZeichenKette,"\r\n");
    /* SendeZeichenKette senden */
    Senden(SendeZeichenKette);
    /* Antwort empfangen */
    Empfangen(EmpfangsZeichenKette);
    /*################################################################*/
    /* Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
	- Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
	- Ist Prfsumme korrekt ?
	- Stimmt die Anzahl der Daten ?
	- Ist Antwort vom richtigen Konverter ? */
    /*################################################################*/
    /* Antwort aus EmpfangsZeichenKette trennen */
    /* String Initialisieren */
    strcpy(ZeichenKette,"");
    if (strlen(EmpfangsZeichenKette)>13)
      {
      /* Antwort isolieren (Dazu wird SendeZeichenKette mibraucht!)*/
      strcpy(SendeZeichenKette,"");
      for (x=10;x<strlen(EmpfangsZeichenKette)-4;x++)
	SendeZeichenKette[x-10]=EmpfangsZeichenKette[x];
      SendeZeichenKette[x-10]=0;	
      /* Zeichen der Antwort in Zielzeichenkette kopieren */
      BinWert=0;
      x=0;
      while (x<strlen(SendeZeichenKette))
	{
	ASCII_Wert[0]=SendeZeichenKette[x];
	ASCII_Wert[1]=SendeZeichenKette[x+1];
	ASCII_Wert[2]=0;
	BinWert=WandelInBinaer(ASCII_Wert);
	sprintf(ASCII_Wert,"%c",BinWert);
	strcat(ZeichenKette,ASCII_Wert);
	x=x+2;
	}
      }
  }
  /*------------------------------------------------------------------*/
void main(void)
  {
  /* Bildschirm lschen */
  clrscr();
  /* RS485-Schnittstelle Initialisieren */
  Init_RS485();
  /* Schleife bis Tastendruck ausfhren */
  do
    /* Es werden die ersten 20 Busteilnehmer angesprochen */
    for (x=1;x<=20;x++)
      {
      /* Gertebezeichnung holen */
      CNV1318A_GER(x,Test);
      gotoxy(1,1+x);
      cprintf("BusNr.%2d ",x);
      cprintf("Gert: %s",Test);
      /* Seriennummer holen */
      CNV1318A_SRN(x,Test);
      gotoxy(26,1+x);
      cprintf("Nr.: %s",Test);
      /* Versionsnummer der Gertesoftware holen */
      CNV1318A_VER(x,Test);
      gotoxy(37,1+x);
      cprintf("Version : %s",Test);
      /* Herstellungsdatum des Gertes holen */
      CNV1318A_DAT(x,Test);
      gotoxy(52,1+x);
      cprintf("Datum : %s",Test);
      /* bertragungsparameter einlesen */
      CNV1318A_GETMD(x,Test);
      gotoxy(65,1+x);
      cprintf("Mode : %s",Test);

      strcpy(Test,"1.23\r\n");
      CNV1318A_CNV(0,Test);
      }
      /* bis Tastendruck */
  while(!kbhit());
  }