program CNV1318A;
{ Diese Datei soll an Beispielfunktionen die Erstellung von Programmen
  fr den Konverters CNV 1318A veranschaulichen. Dabei wird vorrausgesetzt,
  da hier als Host ein PC mit einer RS485-Schnittstelle vom Typ RS1295
  eingesetzt wird.

  Das Programm und deren Funktionen sind nicht optimiert. Die Fehlerfreiheit
  dieses Programmes kann nicht garantiert werden.

  Das Programm liest permanent einige Daten der ersten 20 Bus-Teilnehmer
  ein und stellt sie auf dem Bildschirm dar. Der Konvertierungsbefehl ist
  hier auch implementiert, wird aber durch das Beispielprogramm nicht
  eingesetzt. }
uses Crt;

const
  PC_ADRESSE    = 0;                   { RS485-Adresse des PC's }
  RS485_ADRESSE = $100;                { IO-Adresse der RS485-Schnittstelle }

var
  test   : string;
  x      : Integer;
  {------------------------------------------------------------------}
  procedure WandelInASCII(Wert:Integer; var ZeichenKette:String);
  var
    HighByte,LowByte:Integer;
  begin
    {Integerwert in ASCII wandeln }
    { Byte aufteilen in Nibble }
    HighByte:=(Wert and $F0)DIV 16;
    LowByte :=Wert and 15;
    { Oberes Nibble in Zeichen wandeln }
    if HighByte>9 then
      HighByte:=HighByte+Ord('A')-10
    else
      HighByte:=HighByte+Ord('0');
    { Unteres Nibble in Zeichen wandeln }
    if LowByte>9 then
      LowByte:=LowByte+Ord('A')-10
    else
      LowByte:=LowByte+Ord('0');
    ZeichenKette:=Chr(HighByte)+Chr(LowByte);
  end;
  {------------------------------------------------------------------}
  procedure WandelInBinaer(var Wert:Integer; var ZeichenKette:String);
    function ASCII2HEX(Zeichen:Char):Integer;
    begin
      case Zeichen of
        '0'..'9' : ASCII2HEX:=Ord(Zeichen)-Ord('0');
        'A'..'F' : ASCII2HEX:=Ord(Zeichen)-Ord('A')+10;
      else
        ASCII2HEX:=0;
      end;
    end;
  begin
    { 2-ZeichenASCII-Wert in Binrwert wandeln }
    { Oberes Nibble bearbeiten }
    Wert:=ASCII2HEX(ZeichenKette[1])*16;
    Wert:=Wert+ASCII2HEX(ZeichenKette[2]);
  end;
  {------------------------------------------------------------------}
  procedure PruefsummeEinfuegen(var SendeZeichenKette:string);
  var
    x : Integer;
    y : Integer;
    ASCII_Wert:string;
  begin
    y:=0;
    { Summe der ASCII-Zeichen bilden }
    for x:=1 to Ord(SendeZeichenKette[0]) do
      y:=y+Ord(SendeZeichenKette[x]);
    { Nur 8-Bit Summe verwenden }
    y:=y and $FF;
    { Prfsumme in ASCII-Zeichen wandeln }
    WandelInASCII(y,ASCII_Wert);
    { Prfsumme an Sendezeichenkette anhngen }
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
  end;
  {------------------------------------------------------------------}
  { HINWEIS : Die Initialisierungsroutine ist fr den Einstatz der RS485-Karte vom
    Typ ERMA RS1295 ausgelegt. Die Routine ist im Einzelfall an die
    verwendete RS485-Schnittstelle anzupassen! }
  { RS485-Schnittstelle einstellen (115200,8,N,1) }
  procedure Init_RS485;
  begin
    { Umschalten auf Baudratenteiler }
    Port[RS485_ADRESSE+3]:=$80;
    { Baudrate auf 115200 einstellen }
    Port[RS485_ADRESSE+1]:=$00;
    Port[RS485_ADRESSE  ]:=$01;
    {}
    Port[RS485_ADRESSE+3]:=$03;
    {}
    Port[RS485_ADRESSE+1]:=$00;
    {}
    Port[RS485_ADRESSE+2]:=$03;
  end;
  {------------------------------------------------------------------}
  { HINWEIS : Die Senderoutine ist fr den Einstatz der RS485-Karte vom
    Typ ERMA RS1295 ausgelegt. Die Routine ist im Einzelfall an die
    verwendete RS485-Schnittstelle anzupassen! In dieser Routine wird der
    Einfachheit halber auf die Interruptprogrammierung verzichtet, obwohl
    sie zu empfehlen ist. }
  procedure Senden(var SendeZeichenKette:String);

  var
    x,y     : Integer;
    TimeOut : Integer;
  begin
    { Eingangspuffer lschen (alle Zeichen entfernen) }
    while(Port[RS485_ADRESSE+5] and 1)=1 do y:=Port[RS485_ADRESSE];
    { Ausgangstreiber der RS485-Schnittstelle einschalten }
    Port[RS485_ADRESSE+4]:=$01;
    { String senden }
    for x:=1 to Ord(SendeZeichenKette[0]) do
      begin
      { Zeichen aus String senden }
      Port[RS485_ADRESSE]:=Ord(SendeZeichenKette[x]);
      TimeOut:=0;
      { Warten auf RS485-Echo }
      { HINWEIS: Die hier gewhlte Methode des Timeouts ist nur sehr
        einfach. Der Wert hngt von der gewhlten Baudrate und der
        Computergeschwindigkeit ab. Um einheitliche TimeOut-Zeiten auf
        unterschiedlichen Computersystemen zu erreichen sollte der
        Timer des PC's verwendet werden. }
      while (((Port[RS485_ADRESSE+5] and 1)=0) and (TimeOut<10000)) do Inc(TimeOut);
      { Echo einlesen }
      y:=Port[RS485_ADRESSE];
      { Wenn Fehler beim Senden, dann Ende der bertragung an Konverter
        schicken. }
      if y<>Ord(SendeZeichenKette[x]) then
        begin
        Port[RS485_ADRESSE]:=13;
        Port[RS485_ADRESSE]:=10;
        end
      end;
    { RS485-Treiber ausschalten }
    Port[RS485_ADRESSE+4]:=$00;
  end;
  {------------------------------------------------------------------}
  { HINWEIS : Die Empfangsroutine ist fr den Einstatz der RS485-Karte vom
    Typ ERMA RS1295 ausgelegt. Die Routine ist im Einzelfall an die
    verwendete RS485-Schnittstelle anzupassen! In dieser Routine wird der
    Einfachheit halber auf die Interruptprogrammierung verzichtet, obwohl
    sie zu empfehlen ist. }
  procedure Empfangen(var EmpfangsZeichenKette:String);
  var
    TimeOut  : Integer;
    x,y      : Integer;
    Ende     : Boolean;
  begin
    { Antwort empfangen }
    x:=1;
    Ende:=False;
    EmpfangsZeichenKette:='';
    Timeout:=0;
    repeat
      TimeOut:=0;
      { HINWEIS: Die hier gewhlte Methode des Timeouts ist nur sehr
        einfach. Der Wert hngt von der gewhlten Baudrate und der
        Computergeschwindigkeit ab. Um einheitliche TimeOut-Zeiten auf
        unterschiedlichen Computersystemen zu erreichen sollte der
        Timer des PC's verwendet werden. }
      { Warten auf Zeichen an RS485-Schnittstelle, bzw. auf TimeOut }
      while (((Port[RS485_ADRESSE+5] and 1)=0) and (TimeOut<10000)) do
        begin
        { TimeOut-Zhler erhhen }
        Inc(TimeOut);
        end;
        { Falls kein TimeOut, dann }
        if TimeOut<10000 then
          begin
          { Zeichen von RS485 einlesen }
          y:=Port[RS485_ADRESSE];
          { In Empfangszeichenkette ablegen }
          EmpfangsZeichenKette:=EmpfangsZeichenKette+Chr(y);
          { Prfen auf bertragungsende }
          if EmpfangsZeichenKette[x]=Chr(10) then
            Ende:=True;
          { Zeichenzhler erhhen }
          Inc(x);
          { Wenn mehr als 30 Zeichen, dann abbrechen }
          if x>30 then
            Ende:=True;
          end
        else
          { Bei TimeOut abbrechen }
          Ende:=True;
    until Ende;
  end;
  {------------------------------------------------------------------}
  {##################################################################
   ###            Grundfunktionen fr den CNV1318A                ###
   ##################################################################}
  { Diese Prozedur ermittelt die Gertebezeichnung des Gertes mit der
    angegebenen Busnummer. Dies ist zum Beispiel von Vorteil, wenn
    unterschiedliche Gerte an einem einzigen Bus angeschlossen sind.
    Die ERMA-Megerte mit RS485 kennen das Kommando GER? auch. Somit
    wre zum Beispiel eine automatische Konfiguration mglich. Eine
    zweite Mglichkeit wre, da die Revisionsnummer (hier A) dazu
    benutzt wird, um zu unterscheiden, welche Befehle bei der jeweiligen
    Revision benutzt werden knnen und welche nicht. }
  procedure CNV1318A_GER(BusNummer:Integer; var Bezeichnung:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x                    : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Anzahl der Daten einfgen }
    SendeZeichenKette:=SendeZeichenKette+'04';
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'GER?';
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Bezeichnung aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    Bezeichnung:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Zeichen der Bezeichnung in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      for x:=11 to Ord(EmpfangsZeichenKette[0])-4 do
        Bezeichnung:=Bezeichnung+EmpfangsZeichenKette[x];
    end;
  end;
  {------------------------------------------------------------------}
  { Diese Prozedur ermittelt die Versionsnummer der Software des Gertes
    mit der angegebenen Busnummer. Dies ist zum Beispiel von Vorteil, wenn
    unterschiedliche Versionen eines Gertes an einem einzigen Bus
    angeschlossen sind, da automatisch unterschieden werden kann, welche
    Gerte welche Befehle verstehen. }
  procedure CNV1318A_VER(BusNummer:Integer; var Version:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x                    : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Anzahl der Daten einfgen }
    SendeZeichenKette:=SendeZeichenKette+'04';
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'VER?';
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Versionsnummer aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    Version:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Zeichen der Versionsnummer in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      for x:=11 to Ord(EmpfangsZeichenKette[0])-4 do
        Version:=Version+EmpfangsZeichenKette[x];
    end;
  end;
  {------------------------------------------------------------------}
  { Diese Prozedur ermittelt die Seriennummer des Gertes
    mit der angegebenen Busnummer. }
  procedure CNV1318A_SRN(BusNummer:Integer; var SerienNummer:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x                    : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Anzahl der Daten einfgen }
    SendeZeichenKette:=SendeZeichenKette+'04';
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'SRN?';
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Seriennummer aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    SerienNummer:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Zeichen der Seriennummer in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      for x:=11 to Ord(EmpfangsZeichenKette[0])-4 do
        SerienNummer:=Seriennummer+EmpfangsZeichenKette[x];
    end;
  end;
  {------------------------------------------------------------------}
  { Diese Prozedur ermittelt das Herstellungsdatum des Gertes
    mit der angegebenen Busnummer. }
  procedure CNV1318A_DAT(BusNummer:Integer; var HerstellungsDatum:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x                    : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Anzahl der Daten einfgen }
    SendeZeichenKette:=SendeZeichenKette+'04';
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'DAT?';
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Herstellungsdatum aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    Herstellungsdatum:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Zeichen des Herstellungsdatums in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      for x:=11 to Ord(EmpfangsZeichenKette[0])-4 do
        HerstellungsDatum:=HerstellungsDatum+EmpfangsZeichenKette[x];
    end;
  end;
  {------------------------------------------------------------------}
  { Diese Prozedur ermittelt die bertragungsparameter der RS232 des
    Konverters mit der angegebenen Busnummer. }
  procedure CNV1318A_GETMD(BusNummer:Integer; var Mode:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x                    : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Anzahl der Daten einfgen }
    SendeZeichenKette:=SendeZeichenKette+'06';
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'SETMD?';
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Mode aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    Mode:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Zeichen des Modes in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      for x:=13 to Ord(EmpfangsZeichenKette[0])-4 do
        Mode:=Mode+EmpfangsZeichenKette[x];
    end;
  end;
  {------------------------------------------------------------------}
  { Diese Prozedur setzt die bertragungsparameter der RS232 des
    Konverters mit der angegebenen Busnummer. }
  procedure CNV1318A_SETMD(BusNummer:Integer; var Mode:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x                    : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Anzahl der Daten einfgen }
    SendeZeichenKette:=SendeZeichenKette+'07';
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'SETMD';
    { Mode anfgen }
    SendeZeichenKette:=SendeZeichenKette+Mode;
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Mode aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    Mode:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Zeichen des Modes in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      for x:=13 to Ord(EmpfangsZeichenKette[0])-4 do
        Mode:=Mode+EmpfangsZeichenKette[x];
    end;
  end;
  {------------------------------------------------------------------}
  { Diese Prozedur bertrgt eine Zeichenkette an die RS232 ber den
    Konverters mit der angegebenen Busnummer. }
  { HINWEIS: Der Parameter ZeichenKette wird als Ein- und als Ausgabeparameter
    mibraucht. Beim Prozeduraufruf mu er die Zeichenkette enthalten, die
    an die RS232 bertragen werden soll, nach Beendigung enthlt er die
    Antwort von der RS232 }
  procedure CNV1318A_CNV(BusNummer:Integer; var ZeichenKette:String);
  var
    { zu sendende Zeichenkette }
    SendeZeichenKette    : String;
    { empfangene Zeichenkette }
    EmpfangsZeichenKette : String;
    { 2-Zeichen-ASCII-Wert }
    ASCII_Wert           : String;
    { Hilfsvariable }
    x,y,BinWert          : Integer;
  begin
    { Sendezeichenkette zusammensetzen }
    { erstes Zeichen '#' }
    SendeZeichenKette:='#';
    { BusNummer in ASCII wandeln und einfgen }
    WandelInASCII(BusNummer,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { PC-Nummer in ASCII wandeln und einfgen }
    WandelInASCII(PC_ADRESSE,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;

    { Anzahl der Daten einfgen }
    x:=2*Ord(ZeichenKette[0]);
    x:=x+3;
    WandelInASCII(x,ASCII_Wert);
    SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
    { Befehl einfgen }
    SendeZeichenKette:=SendeZeichenKette+'CNV';
    { Daten einfgen }
    for x:=1 to Ord(ZeichenKette[0]) do
      begin
      y:=Ord(ZeichenKette[x]);
      WandelInASCII(y,ASCII_Wert);
      SendeZeichenKette:=SendeZeichenKette+ASCII_Wert;
      end;
    { Prfsumme berechnen und einfgen }
    PruefsummeEinfuegen(SendeZeichenKette);
    { CR und LF einfgen }
    SendeZeichenKette:=SendeZeichenKette+Chr(13)+Chr(10);
    { SendeZeichenKette senden }
    Senden(SendeZeichenKette);
    { Antwort empfangen }
    Empfangen(EmpfangsZeichenKette);
    {################################################################}
    { Hier sollte die Fehlerprfung eingesetzt werden. Da dieses Programm
      jedoch nur als einfaches Beispielprogramm ausgelegt ist, wird hier
      darauf verzichtet.
      Es gehren zumindest folgende Punkte zur Fehlerprfung:
        - Ist Empfangszeichenkette Antwort oder Fehlermeldung ?
        - Ist Prfsumme korrekt ?
        - Stimmt die Anzahl der Daten ?
        - Ist Antwort vom richtigen Konverter ? }
    {################################################################}
    { Antwort aus EmpfangsZeichenKette trennen }
    { String Initialisieren }
    ZeichenKette:='';
    if Ord(EmpfangsZeichenKette[0])>13 then
      begin
      { Antwort isolieren (Dazu wird SendeZeichenKette mibraucht!)}
      SendeZeichenKette:='';
      for x:=11 to Ord(EmpfangsZeichenKette[0])-4 do
        SendeZeichenKette:=SendeZeichenKette+EmpfangsZeichenKette[x];
      { Zeichen der Antwort in Zielzeichenkette kopieren
        Hinweis: Ord(EmpfangsZeichenKette[0]) liefert die Stringlnge. }
      x:=1;
      while x<=Ord(SendeZeichenKette[0]) do
        begin
        ASCII_Wert:=SendeZeichenKette[x]+SendeZeichenKette[x+1];
        WandelInBinaer(BinWert,ASCII_Wert);
        ZeichenKette:=ZeichenKette+Chr(BinWert);
        x:=x+2;
        end;
    end;
  end;
  {------------------------------------------------------------------}
begin
  { Bildschirm lschen }
  ClrScr;
  { RS485-Schnittstelle Initialisieren }
  Init_RS485;
  { Schleife bis Tastendruck ausfhren }
  repeat
    { Es werden die ersten 20 Busteilnehmer angesprochen }
    for x:=1 to 20 do
      begin
      { Gertebezeichnung holen }
      CNV1318A_GER(x,Test);
      gotoxy(1,1+x);
      Write('BusNr.',x:2,' Gert: ',Test);
      { Seriennummer holen }
      CNV1318A_SRN(x,Test);
      gotoxy(26,1+x);
      Write('Nr.: ',Test);
      { Versionsnummer der Gertesoftware holen }
      CNV1318A_VER(x,Test);
      gotoxy(37,1+x);
      Write('Version : ',Test);
      { Herstellungsdatum des Gertes holen }
      CNV1318A_DAT(x,Test);
      gotoxy(52,1+x);
      Write('Datum : ',Test);
      { bertragungsparameter einlesen }
      CNV1318A_GETMD(x,Test);
      gotoxy(65,1+x);
      Write('Mode : ',Test);
      end;
      { bis Tastendruck }
  until keypressed;
end.